commit 78e1d7a0b53cd75a015e74bb004d9a7bf061f632
Author: Hans Peter Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Fri Jan 4 06:17:28 2019 +0100

    Neues kivitendo Design Aenderungen in templates/webpages/reconciliation/..

diff --git a/templates/webpages/reconciliation/_linked_transactions.html b/templates/webpages/reconciliation/_linked_transactions.html
index c05be857d..d46fcdd40 100644
--- a/templates/webpages/reconciliation/_linked_transactions.html
+++ b/templates/webpages/reconciliation/_linked_transactions.html
@@ -6,17 +6,17 @@
 [% SET debug = 0 %]
 
 [% IF !SELF.LINKED_TRANSACTIONS.size %]
-  <tbody class="listrow">
-    <td colspan="11"><p class="message_hint">[% 'No data was found.' | $T8 %]</p></td>
+  <tbody>
+    <td colspan="11"><p class="message message_hint">[% 'No data was found.' | $T8 %]</p></td>
   </tbody>
 [% ELSE %]
   [% FOREACH link = SELF.LINKED_TRANSACTIONS %]
     [% IF link.type == 'Link' %]
-      <tbody class="listrow">
+      <tbody>
         [% FOREACH bt = link.BT %]
           <tr>
             [% IF loop.count == 1 %]
-              <td rowspan=[% link.BT.size + link.BB.size %] style="valign:center;">
+              <td rowspan="[% link.BT.size + link.BB.size %]" class="button">
                 [% L.button_tag('delete_reconciliation(' _ link.rec_group  _ ')', LxERP.t8("X")) %]
               </td>
             [% END %]
@@ -24,8 +24,8 @@
             <td><img width="16px" height="16px" src="image/bank-building.jpg"></td>
             <td>[% 'Bank Transaction' | $T8 %]</td>
             [% IF debug %]<td>[% HTML.escape(bt.id) %]</td>[% END %]
-            <td align="right" class="[% HTML.escape(bt.class) %]">[% HTML.escape(bt.transdate_as_date) %]</td>
-            <td align="right" class="[% HTML.escape(bt.class) %]">[% HTML.escape(bt.amount_as_number) %]</td>
+            <td class="date right [% HTML.escape(bt.class) %]">[% HTML.escape(bt.transdate_as_date) %]</td>
+            <td class="numeric right [% HTML.escape(bt.class) %]">[% HTML.escape(bt.amount_as_number) %]</td>
             <td></td>
             <td>[% HTML.escape(bt.remote_name) %]</td>
             <td>[% HTML.escape(bt.purpose) %]</td>
@@ -39,9 +39,9 @@
             <td><div class="icon16 general-ledger--reports--journal"></div></td>
             <td>[% 'Acc Transaction' | $T8 %]</td>
             [% IF debug %]<td>[% HTML.escape(bb.acc_trans_id) %]</td>[% END %]
-            <td align="right" class="[% HTML.escape(bb.class) %]">[% HTML.escape(bb.transdate_as_date) %]</td>
+            <td class="date right [% HTML.escape(bb.class) %]">[% HTML.escape(bb.transdate_as_date) %]</td>
             <td></td>
-            <td align="right" class="[% HTML.escape(bb.class) %]">[% LxERP.format_amount(-1 * bb.amount, 2) %]</td>
+            <td class="numeric right [% HTML.escape(bb.class) %]">[% LxERP.format_amount(-1 * bb.amount, 2) %]</td>
             <td>[% HTML.escape(bb.record.customer.name) %][% HTML.escape(bb.record.vendor.name) %][% HTML.escape(bb.record.description) %]</td>
             <td>[% bb.record.link %] [% HTML.escape(bb.source) %] [% HTML.escape(bb.memo) %]</td>
             <td></td>
@@ -61,8 +61,8 @@
             <td><img width="16px" height="16px" src="image/bank-building.jpg"></td>
             <td>[% 'Bank Transaction' | $T8 %]</td>
             [% IF debug %]<td>[% HTML.escape(bt.id) %]</td>[% END %]
-            <td align="right">[% HTML.escape(bt.transdate_as_date) %]</td>
-            <td align="right">[% HTML.escape(bt.amount_as_number) %]</td>
+            <td class="date right">[% HTML.escape(bt.transdate_as_date) %]</td>
+            <td class="numeric right">[% HTML.escape(bt.amount_as_number) %]</td>
             <td></td>
             <td>[% HTML.escape(bt.remote_name) %]</td>
             <td>[% HTML.escape(bt.purpose) %]</td>
@@ -80,9 +80,9 @@
             <td><div class="icon16 general-ledger--reports--journal"></div></td>
             <td>[% 'Acc Transaction' | $T8 %]</td>
             [% IF debug %]<td>[% HTML.escape(bb.acc_trans_id) %]</td>[% END %]
-            <td align="right">[% HTML.escape(bb.transdate_as_date) %]</td>
+            <td class="date right">[% HTML.escape(bb.transdate_as_date) %]</td>
             <td></td>
-            <td align="right">[% LxERP.format_amount(-1 * bb.amount, 2) %]</td>
+            <td class="numeric right">[% LxERP.format_amount(-1 * bb.amount, 2) %]</td>
             <td>[% HTML.escape(bb.record.customer.name) %][% HTML.escape(bb.record.vendor.name) %][% HTML.escape(bb.record.description) %]</td>
             <td>[% bb.record.link %] [% HTML.escape(bb.source) %] [% HTML.escape(bb.memo) %]</td>
             <td></td>
diff --git a/templates/webpages/reconciliation/assigning_table.html b/templates/webpages/reconciliation/assigning_table.html
index ec8b5ed11..c71ff6d42 100644
--- a/templates/webpages/reconciliation/assigning_table.html
+++ b/templates/webpages/reconciliation/assigning_table.html
@@ -1,9 +1,9 @@
 [%- USE HTML -%][%- USE LxERP -%][%- USE L -%][%- USE T8 -%]
 
 [% IF SELF.ELEMENTS.size %]
-<table>
+<table class="tbl-horizontal test">
   <thead>
-    <tr class="listheading">
+    <tr>
       <th></th>
       <th>[% 'ID' | $T8 %]</th>
       <th>[% 'Type' | $T8 %]</th>
@@ -12,28 +12,29 @@
       <th>[% 'Amount BB' | $T8 %]</th>
     </tr>
   </thead>
+  <!-- PENDENT: tbody#assigned_elements war in der foreach-Schlaufe, was falsch ist. Ueberpruefen -->
+  <tbody id="assigned_elements">
   [% FOREACH element = SELF.ELEMENTS %]
-    <tbody id="assigned_elements">
-      <tr class="listrow" id='element[% element.type %][% element.id %]'>
-       <td><a href=# onclick="delete_element('[% element.id %]', '[% element.type %]')">x</a></td>
-       <td>[% HTML.escape(element.id) %]</td>
-       <td>[% IF element.type == 'BT' %][% 'Bank transaction' | $T8 %][% ELSE %][% 'Acc transaction' | $T8 %][% END %]</td>
-       <td>[% HTML.escape(element.transdate_as_date) %]</td>
-       <td align="right">[% IF element.type == 'BT' %][% HTML.escape(element.amount_as_number) %][% END %]</td>
-       <td align="right">[% IF element.type == 'BB' %][% LxERP.format_amount(-1 * element.amount, 2) %][% END %]</td>
-      </tr>
-    </tbody>
-  [% END %]
-  <tbody>
-    <tr class="listrow">
-      <td class="listtotal top_border"></td>
-      <td class="listtotal top_border"></td>
-      <td class="listtotal top_border"></td>
-      <td class="listtotal top_border"></td>
-      <td class="listtotal top_border">[% bt_sum %]</td>
-      <td class="listtotal top_border">[% bb_sum %]</td>
+    <tr id="element[% element.type %][% element.id %]">
+     <td><a href="#" onclick='delete_element("[% element.id %]", "[% element.type %]")'>x</a></td>
+     <td>[% HTML.escape(element.id) %]</td>
+     <td>[% IF element.type == 'BT' %][% 'Bank transaction' | $T8 %][% ELSE %][% 'Acc transaction' | $T8 %][% END %]</td>
+     <td>[% HTML.escape(element.transdate_as_date) %]</td>
+     <td class="numeric right">[% IF element.type == 'BT' %][% HTML.escape(element.amount_as_number) %][% END %]</td>
+     <td class="numeric right">[% IF element.type == 'BB' %][% LxERP.format_amount(-1 * element.amount, 2) %][% END %]</td>
     </tr>
+  [% END %]
   </tbody>
+  <tfoot>
+    <tr>
+      <td></td>
+      <td></td>
+      <td></td>
+      <td></td>
+      <td class="numeric">[% bt_sum %]</td>
+      <td class="numeric">[% bb_sum %]</td>
+    </tr>
+  </tfoot>
 </table>
   [% UNLESS errors %]
    [% L.button_tag("submit_with_action('reconcile')", LxERP.t8("Reconcile")) %]
diff --git a/templates/webpages/reconciliation/form.html b/templates/webpages/reconciliation/form.html
index 926ff7988..70208cdee 100644
--- a/templates/webpages/reconciliation/form.html
+++ b/templates/webpages/reconciliation/form.html
@@ -3,33 +3,16 @@
 [%- USE LxERP %]
 [%- USE L %]
 
-<style type="text/css">
-<!--
-html, body {
-  height: 100%;
-}
-.top_border {
-  border-top: solid black;
-  border-width: 4px;
-}
-.bottom_border {
-  border-bottom: solid black;
-  border-width: 4px;
-}
-#content.html-menu { height: 100%; }
-.out_of_balance {
-  color: #888888;
-}
--->
-</style>
+<h1>[% title %]</h1>
 
-<div class="listtop">[% title %]</div>
 [%- INCLUDE 'common/flash.html' %]
 
-<form id="reconciliation_form" method="post" action="controller.pl" style="height:100%" id="filter_form">
-  <table>
+<form id="reconciliation_form" method="post" action="controller.pl" id="filter_form">
+
+  <table class="tbl-horizontal test">
+    <tbody>
     <tr>
-     <th align="right">[% 'Bank account' | $T8 %]</th>
+     <th>[% 'Bank account' | $T8 %]</th>
      <td>[% L.select_tag('filter.local_bank_account_id:number',
                           SELF.BANK_ACCOUNTS,
                           default=FORM.filter.local_bank_account_id_number,
@@ -40,57 +23,58 @@ html, body {
     </tr>
 
     <tr>
-     <th align="right">[% 'From' | $T8 %]</th>
+     <th>[% 'From' | $T8 %]</th>
      <td>[% L.date_tag('filter.fromdate:date::ge', FORM.filter.fromdate_date__ge, onchange='filter_table();') %]</td>
-     <th align="right">[% 'to (date)' | $T8 %]</th>
+     <th>[% 'to (date)' | $T8 %]</th>
      <td>[% L.date_tag('filter.todate:date::le', FORM.filter.todate_date__le, onchange='filter_table();') %]</td>
     </tr>
 
     <tr>
-     <th align="right">[% 'Cleared/uncleared only' | $T8 %]</th>
+     <th>[% 'Cleared/uncleared only' | $T8 %]</th>
      <td>[% L.select_tag('filter.cleared:eq_ignore_empty', SELF.cleared, value_key = 'value', title_key = 'title', default=FORM.filter.cleared_eq_ignore_empty, onchange='filter_table();') %]</td>
     </tr>
 
     <tr>
-     <th align="right">[% 'Show Stornos' | $T8 %]</th>
+     <th>[% 'Show Stornos' | $T8 %]</th>
      <td>[% L.checkbox_tag('filter.show_stornos', checked=FORM.filter.show_stornos, value='1', onchange='filter_table();') %]</td>
     </tr>
 
     <tr>
-     <th align="right">[% 'Absolute BT Balance' | $T8 %]</th>
-     <td class='absolut_bt_balance'>[% LxERP.format_amount(SELF.absolut_bt_balance, 2) %]</td>
+     <th>[% 'Absolute BT Balance' | $T8 %]</th>
+     <td class="absolut_bt_balance">[% LxERP.format_amount(SELF.absolut_bt_balance, 2) %]</td>
     </tr>
 
     <tr>
-     <th align="right">[% 'Absolute BB Balance' | $T8 %]</th>
-     <td class='absolut_bb_balance'>[% LxERP.format_amount(-1 * SELF.absolut_bb_balance, 2) %]</td>
+     <th>[% 'Absolute BB Balance' | $T8 %]</th>
+     <td class="absolut_bb_balance">[% LxERP.format_amount(-1 * SELF.absolut_bb_balance, 2) %]</td>
     </tr>
 
     <tr>
-     <th align="right">[% 'BT Balance' | $T8 %]</th>
-     <td class='bt_balance'>[% LxERP.format_amount(SELF.bt_balance, 2) %]</td>
+     <th>[% 'BT Balance' | $T8 %]</th>
+     <td class="bt_balance">[% LxERP.format_amount(SELF.bt_balance, 2) %]</td>
     </tr>
 
     <tr>
-     <th align="right">[% 'BB Balance' | $T8 %]</th>
-     <td class='bb_balance'>[% LxERP.format_amount(-1 * SELF.bb_balance, 2) %]</td>
+     <th>[% 'BB Balance' | $T8 %]</th>
+     <td class="bb_balance">[% LxERP.format_amount(-1 * SELF.bb_balance, 2) %]</td>
     </tr>
+    </tbody>
   </table>
 
   <div id="reconc_tabs" class="tabwidget" style="height:100%">
     <ul>
-      <li><a href="#overview" onclick="load_overview();">[% 'Overview' | $T8 %]</a></li>
-      <li><a href="#automatic" onclick="load_proposals();">[% 'Proposals' | $T8 %]</a></li>
+      <li><a href="#overview" onclick='load_overview();'>[% 'Overview' | $T8 %]</a></li>
+      <li><a href="#automatic" onclick='load_proposals();'>[% 'Proposals' | $T8 %]</a></li>
     </ul>
 
     <div id="overview" style="height:calc(100% - 60px);overflow: auto;">
     [%- IF ui_tab == 0 %]
-    [% PROCESS "reconciliation/tabs/overview.html" %]
+      [% PROCESS "reconciliation/tabs/overview.html" %]
     [%- END %]</div>
     <div id="automatic" style="height:calc(100% - 60px);overflow: auto;">
     [%- IF ui_tab == 1 %]
-    [% PROCESS "reconciliation/tabs/automatic.html" %]
-    [%- END %]    </div>
+      [% PROCESS "reconciliation/tabs/automatic.html" %]
+    [%- END %]</div>
   </div>
 
 </form>
diff --git a/templates/webpages/reconciliation/proposals.html b/templates/webpages/reconciliation/proposals.html
index df7bde432..9f96d2d71 100644
--- a/templates/webpages/reconciliation/proposals.html
+++ b/templates/webpages/reconciliation/proposals.html
@@ -7,7 +7,7 @@
 
 [% IF !SELF.PROPOSALS.size %]
   <tbody class="listrow">
-    <td colspan="11"><p class="message_hint">[% 'No data was found.' | $T8 %]</p></td>
+    <td colspan="11"><p class="message message_hint">[% 'No data was found.' | $T8 %]</p></td>
   </tbody>
 [% ELSE %]
   [% FOREACH proposal = SELF.PROPOSALS %]
diff --git a/templates/webpages/reconciliation/search.html b/templates/webpages/reconciliation/search.html
index 7ed1986fc..92e3b74c4 100644
--- a/templates/webpages/reconciliation/search.html
+++ b/templates/webpages/reconciliation/search.html
@@ -1,38 +1,36 @@
-[%- USE T8 %]
-[%- USE HTML %]
-[%- USE L %]
-[%- USE LxERP %]
+[% USE T8 %]
+[% USE HTML %]
+[% USE L %]
+[% USE LxERP %]
 
+<h1>[% 'Reconciliation of bank accounts' | $T8 %]</h1>
 <form method="post" action="controller.pl" id="search_form">
 
-<div class="listtop">[% 'Choose bank account for reconciliation' | $T8 %]</div>
-
-<p>
- <table>
-  <tr>
-   <th align="right">[% 'Bank account' | $T8 %]</th>
-   <td>[% L.select_tag('filter.local_bank_account_id:number', SELF.BANK_ACCOUNTS, title_key='displayable_name', with_empty=0, style='width:450px') %]</td>
-  </tr>
-
-  <tr>
-   <th align="right">[% 'From' | $T8 %]</th>
-   <td>[% L.date_tag('filter.fromdate:date::ge') %]</td>
-  </tr>
-
-  <tr>
-   <th align="right">[% 'to (date)' | $T8 %]</th>
-   <td>[% L.date_tag('filter.todate:date::le') %]</td>
-  </tr>
-
-  <tr>
-   <th align="right">[% 'Cleared/uncleared only' | $T8 %]</th>
-   <td>[% L.select_tag('filter.cleared:eq_ignore_empty', SELF.cleared, value_key = 'value', title_key = 'title', default = 'FALSE' ) %]</td>
-  </tr>
-
-  <tr>
-   <th align="right">[% 'Show Stornos' | $T8 %]</th>
-   <td>[% L.checkbox_tag('filter.show_stornos', value='1') %]</td>
-  </tr>
- </table>
-</p>
+<div class="wrapper">
+  <table class="tbl-horizontal">
+    <caption>[% 'Choose bank account for reconciliation' | $T8 %]</caption>
+    <tbody>
+      <tr>
+       <th>[% 'Bank account' | $T8 %]</th>
+       <td>[% L.select_tag('filter.local_bank_account_id:number', SELF.BANK_ACCOUNTS, title_key='displayable_name', with_empty=0, class='wi-wide') %]</td>
+      </tr>
+      <tr>
+       <th>[% 'From' | $T8 %]</th>
+       <td><span class="wi-date">[% L.date_tag('filter.fromdate:date::ge') %]</span></td>
+      </tr>
+      <tr>
+       <th>[% 'to (date)' | $T8 %]</th>
+       <td><span class="wi-date">[% L.date_tag('filter.todate:date::le') %]</span></td>
+      </tr>
+      <tr>
+       <th>[% 'Cleared/uncleared only' | $T8 %]</th>
+       <td>[% L.select_tag('filter.cleared:eq_ignore_empty', SELF.cleared, value_key = 'value', title_key = 'title', default = 'FALSE', class='wi-wide' ) %]</td>
+      </tr>
+      <tr>
+       <th>[% 'Show Stornos' | $T8 %]</th>
+       <td>[% L.checkbox_tag('filter.show_stornos', value='1') %]</td>
+      </tr>
+    </tbody>
+   </table>
+</div>
 </form>
diff --git a/templates/webpages/reconciliation/tabs/automatic.html b/templates/webpages/reconciliation/tabs/automatic.html
index 7c4934653..6e981f6cb 100644
--- a/templates/webpages/reconciliation/tabs/automatic.html
+++ b/templates/webpages/reconciliation/tabs/automatic.html
@@ -1,13 +1,13 @@
-[%- USE T8 %]
-[%- USE HTML %]
-[%- USE LxERP %]
-[%- USE L %]
+[% USE T8 %]
+[% USE HTML %]
+[% USE LxERP %]
+[% USE L %]
 
 [% SET debug = 0 %]
 
 <table width=100% id="proposal_table">
   <thead>
-    <tr class="listheading">
+    <tr>
       <th>[% L.checkbox_tag('proposal_check_all') %]</th>
 
       <th></th>
diff --git a/templates/webpages/reconciliation/tabs/overview.html b/templates/webpages/reconciliation/tabs/overview.html
index 18842b2ea..929d7ee6c 100644
--- a/templates/webpages/reconciliation/tabs/overview.html
+++ b/templates/webpages/reconciliation/tabs/overview.html
@@ -1,14 +1,14 @@
-[%- USE T8 %]
-[%- USE HTML %]
-[%- USE LxERP %]
-[%- USE L %]
+[% USE T8 %]
+[% USE HTML %]
+[% USE LxERP %]
+[% USE L %]
 
 [% SET debug = 0 %]
 
   <div style="height:500px; overflow:auto;">
     <table width=99% id="link_table">
       <thead>
-        <tr class="listheading">
+        <tr>
           <th></th>
 
           <th></th>
@@ -33,8 +33,8 @@
           <td class="top_border"></td>
           <td class="top_border"></td>
           <td class="top_border"></td>
-          <td class="bt_balance top_border" align="right">[% LxERP.format_amount(SELF.bt_balance, 2) %]</td>
-          <td class="bb_balance top_border" align="right">[% LxERP.format_amount(-1 * SELF.bb_balance, 2) %]</td>
+          <td class="bt_balance top_border">[% LxERP.format_amount(SELF.bt_balance, 2) %]</td>
+          <td class="bb_balance top_border">[% LxERP.format_amount(-1 * SELF.bb_balance, 2) %]</td>
           <td class="top_border"></td>
           <td class="top_border"></td>
           <td class="top_border"></td>