commit f81dcf3479f34b5299491ea5df476ddf977379b9
Author: Werner Hahn <wh@futureworldsearch.net>
Date:   Tue Sep 26 12:30:06 2017 +0200

    WebshopApi: locales

diff --git a/locale/de/all b/locale/de/all
index 5340614b1..d7a4c030e 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -2010,12 +2010,12 @@ $self->{texts} = {
   'November'                    => 'November',
   'Number'                      => 'Nummer',
   'Number Format'               => 'Zahlenformat',
-  'Number data sets'            => 'Anzahl Datensätze',
   'Number missing in Row'       => 'Nummer fehlt in Zeile',
   'Number of Data: '            => 'Anzahl Datensätze',
   'Number of bins'              => 'Anzahl Lagerpl&auml;tze',
   'Number of columns of custom variables in form details (second row)' => 'Anzahl der Spalten für benutzerdef. Variablen in den Formulardetails (zweite Positionszeile)',
   'Number of copies'            => 'Anzahl Kopien',
+  'Number of data sets'         => 'Anzahl Datensätze',
   'Number of data uploaded:'    => 'Uploaded Datensätze',
   'Number of deliveryorders created:' => 'Anzahl erzeugter Lieferscheine:',
   'Number of deliveryorders printed:' => 'Anzahl gedruckter Lieferscheine:',
@@ -3093,9 +3093,9 @@ $self->{texts} = {
   'The connection to the configured client database "#1" on host "#2:#3" failed.' => 'Die Verbindung zur konfigurierten Datenbank "#1" auf Host "#2:#3" schlug fehl.',
   'The connection to the database could not be established.' => 'Die Verbindung zur Datenbank konnte nicht hergestellt werden.',
   'The connection to the shop could not be established.' => 'Es konnte keine Verbindung zum Shop hergestellt werden',
+  'The connection to the shop was established successfully.' => 'Die Verbindung konnte erfolgreich hergestellt werden',
   'The connection to the template database failed:' => 'Die Verbindung zur Vorlagendatenbank schlug fehl:',
   'The connection was established successfully.' => 'Die Verbindung zur Datenbank wurde erfolgreich hergestellt.',
-  'The connection was to the shop established successfully.' => 'Die Verbindung zum Shop ist erfolgreich',
   'The contact person attribute "birthday" is converted from a free-form text field into a date field.' => 'Das Kontaktpersonenfeld "Geburtstag" wird von einem freien Textfeld auf ein Datumsfeld umgestellt.',
   'The creation of the authentication database failed:' => 'Das Anlegen der Authentifizierungsdatenbank schlug fehl:',
   'The custom variable has been created.' => 'Die benutzerdefinierte Variable wurde erfasst.',
diff --git a/locale/en/all b/locale/en/all
index 945aa2b4f..d3a9759a3 100644
--- a/locale/en/all
+++ b/locale/en/all
@@ -506,6 +506,7 @@ $self->{texts} = {
   'Calculate due date automatically' => '',
   'Calling #1 now'              => '',
   'Can not create that quantity with current stock' => '',
+  'Can\'t connect to shop. #1'  => '',
   'Can\'t load item without a valid part.id' => '',
   'Cancel'                      => '',
   'Cancel Accounts Payables Transaction' => '',
@@ -579,7 +580,9 @@ $self->{texts} = {
   'Chartaccounts connected to this Tax:' => '',
   'Charts'                      => '',
   'Check'                       => 'Cheque',
+  'Check Api'                   => '',
   'Check Details'               => '',
+  'Check connectivity'          => '',
   'Check for duplicates'        => '',
   'Check full signature'        => '',
   'Check on ap transaction'     => '',
@@ -1212,6 +1215,7 @@ $self->{texts} = {
   'Error in row #1: The quantity you entered is bigger than the stocked quantity.' => '',
   'Error message from the database driver:' => '',
   'Error message from the database: #1' => '',
+  'Error message from the webshop api:' => '',
   'Error when saving: #1'       => '',
   'Error with default taxzone'  => '',
   'Error!'                      => '',
@@ -1298,6 +1302,7 @@ $self->{texts} = {
   'Exchangerate Difference'     => '',
   'Exchangerate for payment missing!' => '',
   'Exchangerate missing!'       => '',
+  'Execute'                     => '',
   'Executed'                    => '',
   'Execution date'              => '',
   'Execution date from'         => '',
@@ -1410,7 +1415,8 @@ $self->{texts} = {
   'From'                        => '',
   'From Date'                   => '',
   'From bin'                    => '',
-  'From shop #1 :  #2 shoporders has been fetched' => '',
+  'From shop "#1" :  #2 '       => '',
+  'From shop #1 :  #2 shoporders have been fetched.' => '',
   'From this version on a new feature is available.' => '',
   'From this version on it is necessary to name a default value.' => '',
   'From this version on the partnumber of services, articles and assemblies have to be unique.' => '',
@@ -1557,6 +1563,7 @@ $self->{texts} = {
   'Import profiles'             => '',
   'Import result'               => '',
   'Import scanned documents'    => '',
+  'Importdate'                  => '',
   'In order to do that hit the button "Delete transaction".' => '',
   'In order to migrate the old folder structure into the new structure you have to chose which client the old structure will be assigned to.' => '',
   'In order to use kivitendo you have to create at least a client, a user and a group.' => '',
@@ -1581,6 +1588,7 @@ $self->{texts} = {
   'Incorrect username or password or no access to selected client!' => '',
   'Increase'                    => '',
   'Individual Items'            => '',
+  'Info'                        => '',
   'Information'                 => '',
   'Initial version.'            => '',
   'Insert'                      => '',
@@ -1745,6 +1753,7 @@ $self->{texts} = {
   'List of jobs'                => '',
   'List of tax zones'           => '',
   'List open SEPA exports'      => '',
+  'Listprice'                   => '',
   'Load'                        => '',
   'Load an existing draft'      => '',
   'Load letter draft'           => '',
@@ -2001,12 +2010,12 @@ $self->{texts} = {
   'November'                    => '',
   'Number'                      => '',
   'Number Format'               => '',
-  'Number data sets'            => '',
   'Number missing in Row'       => '',
   'Number of Data: '            => '',
   'Number of bins'              => '',
   'Number of columns of custom variables in form details (second row)' => '',
   'Number of copies'            => '',
+  'Number of data sets'         => '',
   'Number of data uploaded:'    => '',
   'Number of deliveryorders created:' => '',
   'Number of deliveryorders printed:' => '',
@@ -2038,6 +2047,8 @@ $self->{texts} = {
   'One of the columns "qty" or "target_qty" must be given. If "target_qty" is given, the quantity to transfer for each transfer will be calculate, so that the quantity for this part, warehouse and bin will result in the given "target_qty" after each transfer.' => '',
   'One or more Perl modules missing' => '',
   'Onhand only sets the quantity in master data, not in inventory. This is only a legacy info field and will be overwritten as soon as a inventory transfer happens.' => '',
+  'Only Price'                  => '',
+  'Only Stock'                  => '',
   'Only Warnings and Errors'    => '',
   'Only applies if the previous is set to true. When filling up unlinked positions, consider them matches if ALL of these fields match. For example, in a business with variants that are defined by a special description, description needs to be part of the identity. If delivering several similar order positions by delivery date is common, reqdate should be included in the identity. Serialnumber is useful when the serialnumber in the order and delivery order has to match.' => '',
   'Only booked accounts'        => '',
@@ -2134,6 +2145,7 @@ $self->{texts} = {
   'Part with partnumber: #1 not found' => '',
   'PartClassAbbreviation'       => '',
   'Part_br_Description'         => 'Description',
+  'Partdescriptipion'           => '',
   'Partial invoices'            => '',
   'Partnumber'                  => '',
   'Parts'                       => '',
@@ -2233,7 +2245,6 @@ $self->{texts} = {
   'Poland'                      => '',
   'Port'                        => '',
   'Portrait'                    => '',
-  'Position identity fields for fill up?' => '',
   'Position'                    => '',
   'Position identity fields for fill up?' => '',
   'Position type in quotation/order' => '',
@@ -2278,6 +2289,7 @@ $self->{texts} = {
   'Price Source'                => '',
   'Price Sources to be disabled in this client' => '',
   'Price Types'                 => '',
+  'Price and Stock'             => '',
   'Price factor (database ID)'  => '',
   'Price factor (name)'         => '',
   'Price group'                 => '',
@@ -2287,7 +2299,9 @@ $self->{texts} = {
   'Price information'           => '',
   'Price or discount must not be zero.' => '',
   'Price rules must have at least one rule.' => '',
+  'Price source'                => '',
   'Price sources deactivated in this client' => '',
+  'Price type'                  => '',
   'Price type explanation'      => '',
   'Pricegroup'                  => '',
   'Pricegroups'                 => '',
@@ -2348,6 +2362,7 @@ $self->{texts} = {
   'Projecttransactions'         => '',
   'Proposal'                    => '',
   'Proposals'                   => '',
+  'Protocol'                    => '',
   'Prozentual/Absolut'          => '',
   'Purchase'                    => 'Purchase',
   'Purchase (typeabbreviation)' => 'P',
@@ -2844,6 +2859,7 @@ $self->{texts} = {
   'Solution'                    => '',
   'Sorry, I am too stupid to figure out the default warehouse/bin and the sold qty. I drop the default warehouse/bin option.' => '',
   'Sort By'                     => '',
+  'Sort order'                  => '',
   'Source'                      => '',
   'Source BIC'                  => '',
   'Source IBAN'                 => '',
@@ -3075,9 +3091,9 @@ $self->{texts} = {
   'The connection to the authentication database failed:' => '',
   'The connection to the configured client database "#1" on host "#2:#3" failed.' => '',
   'The connection to the database could not be established.' => '',
+  'The connection to the shop could not be established.' => '',
+  'The connection to the shop was established successfully.' => '',
   'The connection to the template database failed:' => '',
-  'The connection to the webshop was not successful. Message: #1 -- URL: #2 -- Datatype: #3' => '',
-  'The connection to the webshop was successful. Version: #1 -- Revision: #2' => '',
   'The connection was established successfully.' => '',
   'The contact person attribute "birthday" is converted from a free-form text field into a date field.' => '',
   'The creation of the authentication database failed:' => '',
@@ -3190,11 +3206,13 @@ $self->{texts} = {
   'The password is too long (maximum length: #1).' => '',
   'The password is too short (minimum length: #1).' => '',
   'The password is weak (e.g. it can be found in a dictionary).' => '',
+  'The path is missing.'        => '',
   'The payment term has been created.' => '',
   'The payment term has been deleted.' => '',
   'The payment term has been saved.' => '',
   'The payment term is in use and cannot be deleted.' => '',
   'The payments have been posted.' => '',
+  'The port is missing.'        => '',
   'The preferred one is to install packages provided by your operating system distribution (e.g. Debian or RPM packages).' => '',
   'The price rule for this discount does not exist anymore' => '',
   'The price rule for this price does not exist anymore' => '',
@@ -3249,6 +3267,7 @@ $self->{texts} = {
   'The shop part has been created.' => '',
   'The shop part has been saved.' => '',
   'The shop part wasn\'t updated.' => '',
+  'The shop part wasn\'t updated. #1' => '',
   'The source warehouse does not contain any bins.' => '',
   'The start date is missing.'  => '',
   'The subject is missing.'     => '',
@@ -3565,12 +3584,14 @@ $self->{texts} = {
   'Updating items with sections' => '',
   'Updating prices of existing entry in database' => '',
   'Updating the client fields in the database "#1" on host "#2:#3" failed.' => '',
+  'Upload'                      => '',
   'Upload Attachments'          => '',
   'Upload Images'               => '',
+  'Upload all marked'           => '',
   'Upload file'                 => '',
-  'Upload shopimage'            => '',
   'Uploaded at'                 => '',
   'Uploaded on #1, size #2 kB'  => '',
+  'Uploading Data'              => '',
   'UsageE'                      => 'Report about stock withdrawal',
   'UsageWithout'                => 'Usage (without correction)',
   'Use As New'                  => '',
@@ -3648,6 +3669,7 @@ $self->{texts} = {
   'Version'                     => '',
   'Version actions'             => '',
   'Version number'              => '',
+  'Version: '                   => '',
   'Versions'                    => '',
   'View SEPA export'            => '',
   'View background job execution result' => '',
@@ -3860,6 +3882,7 @@ $self->{texts} = {
   'for date'                    => '',
   'found'                       => '',
   'found_br'                    => 'found',
+  'from'                        => '',
   'from \'#1\' imported Files'  => '',
   'from (time)'                 => '',
   'general_ledger_list'         => '',
@@ -3926,6 +3949,7 @@ $self->{texts} = {
   'not running'                 => '',
   'not set'                     => '',
   'not shipped'                 => '',
+  'not transferred'             => '',
   'not transferred in yet'      => '',
   'not transferred out yet'     => '',
   'not yet executed'            => '',
@@ -4011,10 +4035,12 @@ $self->{texts} = {
   'taxnumber'                   => '',
   'terminated'                  => '',
   'time and effort based position' => '',
+  'to'                          => '',
   'to (date)'                   => '',
   'to (set to)'                 => '',
   'to (time)'                   => '',
   'transfer'                    => '',
+  'transferred'                 => '',
   'transferred in'              => '',
   'transferred in / out'        => '',
   'transferred out'             => '',