commit 8bf82ed2a2002da54411047637ce03d79beae73a
Author: Geoffrey Richardson <information@kivitendo-premium.de>
Date:   Mon Apr 3 08:36:18 2017 +0200

    BWA Template nutzt Überschriften aus AM->get_bwa_categories

diff --git a/SL/RP.pm b/SL/RP.pm
index e6aecd9eb..ef43307a6 100644
--- a/SL/RP.pm
+++ b/SL/RP.pm
@@ -1653,9 +1653,7 @@ sub bwa {
     keys %{ $form->{charts} };
   $form->{"charts_by_category"} = \%charts_by_category;
 
-  # $main::lxdebug->dump(0, "charts_by_category", $form->{charts_by_category} );
-
-  $form->{category_names} = { selectall_as_map($form, $dbh, "select * from bwa_categories order by id", 'id', 'description') };
+  $form->{category_names} = AM->get_bwa_categories($myconfig, $form);
 
   my @periods        = qw(jetzt kumm);
   my @gesamtleistung = qw(1 3);
diff --git a/templates/webpages/rp/bwa.html b/templates/webpages/rp/bwa.html
index 7da5aa7f1..083f0f01b 100644
--- a/templates/webpages/rp/bwa.html
+++ b/templates/webpages/rp/bwa.html
@@ -38,7 +38,8 @@
 <tr class="white"><td class="left right" colspan="11">&nbsp;</td></tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Umsatzerl&ouml;se</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(1)) %]</td>
+ </nobr></td>
   <td><nobr>[% jetzt1 %]</nobr></td>
   <td><nobr>[% jetztgl1 %]</nobr></td>
   <td></td>
@@ -52,7 +53,7 @@
 </tr>
 
 <tr class="white">
-  <td class="left"><nobr>Best.Verdg. FE/UE</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(2)) %]</nobr></td>
   <td><nobr>[% jetzt2 %]</nobr></td>
   <td><nobr>[% jetztgl2 %]</nobr></td>
   <td></td>
@@ -66,7 +67,7 @@
 </tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Akt.Eigenleistungen</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(3)) %]</nobr></td>
   <td><nobr>[% jetzt3 %]</nobr></td>
   <td><nobr>[% jetztgl3 %]</nobr></td>
   <td></td>
@@ -98,7 +99,7 @@
 <tr class="white"><td class="left right" colspan="11">&nbsp;</td></tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Mat./Wareneinkauf</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(4)) %]</nobr></td>
   <td><nobr>[% jetzt4 %]</nobr></td>
   <td><nobr>[% jetztgl4 %]</nobr></td>
   <td><nobr>[% jetztgk4 %]</nobr></td>
@@ -130,7 +131,7 @@
 <tr class="white"><td class="left right" colspan="11">&nbsp;</td></tr>
 
 <tr class="grey">
-  <td class="left"><nobr>So.betr.Erl&ouml;se</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(5)) %]</nobr></td>
   <td><nobr>[% jetzt5 %]</nobr></td>
   <td><nobr>[% jetztgl5 %]</nobr></td>
   <td><nobr>[% jetztgk5 %]</nobr></td>
@@ -168,7 +169,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="white">
-  <td class="left"><nobr>Personalkosten</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(10)) %]</nobr></td>
   <td><nobr>[% jetzt10 %]</nobr></td>
   <td><nobr>[% jetztgl10 %]</nobr></td>
   <td><nobr>[% jetztgk10 %]</nobr></td>
@@ -182,7 +183,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Raumkosten</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(11)) %]</nobr></td>
   <td><nobr>[% jetzt11 %]</nobr></td>
   <td><nobr>[% jetztgl11 %]</nobr></td>
   <td><nobr>[% jetztgk11 %]</nobr></td>
@@ -196,7 +197,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="white">
-  <td class="left"><nobr>Betriebl.Steuern</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(12)) %]</nobr></td>
   <td><nobr>[% jetzt12 %]</nobr></td>
   <td><nobr>[% jetztgl12 %]</nobr></td>
   <td><nobr>[% jetztgk12 %]</nobr></td>
@@ -210,7 +211,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Versich./Beitr&auml;ge</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(13)) %]</nobr></td>
   <td><nobr>[% jetzt13 %]</nobr></td>
   <td><nobr>[% jetztgl13 %]</nobr></td>
   <td><nobr>[% jetztgk13 %]</nobr></td>
@@ -224,7 +225,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Kfz-Kosten (o.St.)</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(14)) %]</nobr></td>
   <td><nobr>[% jetzt14 %]</nobr></td>
   <td><nobr>[% jetztgl14 %]</nobr></td>
   <td><nobr>[% jetztgk14 %]</nobr></td>
@@ -238,7 +239,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="white">
-  <td class="left"><nobr>Werbe-/Reisekosten</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(15)) %]</nobr></td>
   <td><nobr>[% jetzt15 %]</nobr></td>
   <td><nobr>[% jetztgl15 %]</nobr></td>
   <td><nobr>[% jetztgk15 %]</nobr></td>
@@ -252,7 +253,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Kosten Warenabgabe</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(16)) %]Kosten </nobr></td>
   <td><nobr>[% jetzt16 %]</nobr></td>
   <td><nobr>[% jetztgl16 %]</nobr></td>
   <td><nobr>[% jetztgk16 %]</nobr></td>
@@ -267,7 +268,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="white">
-  <td class="left"><nobr>Abschreibungen</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(17)) %]</nobr></td>
   <td><nobr>[% jetzt17 %]</nobr></td>
   <td><nobr>[% jetztgl17 %]</nobr></td>
   <td><nobr>[% jetztgk17 %]</nobr></td>
@@ -281,7 +282,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Reparatur/Instandh.</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(18)) %]</nobr></td>
   <td><nobr>[% jetzt18 %]</nobr></td>
   <td><nobr>[% jetztgl18 %]</nobr></td>
   <td><nobr>[% jetztgk18 %]</nobr></td>
@@ -295,7 +296,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="white">
-  <td class="left"><nobr>Sonstige Kosten</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(20)) %]</nobr></td>
   <td><nobr>[% jetzt20 %]</nobr></td>
   <td><nobr>[% jetztgl20 %]</nobr></td>
   <td><nobr>[% jetztgk20 %]</nobr></td>
@@ -344,7 +345,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 <tr class="white"><td class="left right" colspan="11">&nbsp;</td></tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Zinsaufwand</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(30)) %]</nobr></td>
   <td><nobr>[% jetzt30 %]</nobr></td>
   <td><nobr>[% jetztgl30 %]</nobr></td>
   <td><nobr>[% jetztgk30 %]</nobr></td>
@@ -358,7 +359,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="white">
-  <td class="left"><nobr>&Uuml;brige Steuern</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(19)) %]</nobr></td>
   <td><nobr>[% jetzt19 %]</nobr></td>
   <td><nobr>[% jetztgl19 %]</nobr></td>
   <td><nobr>[% jetztgk19 %]</nobr></td>
@@ -372,7 +373,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Sonst. neutr. Aufwand</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(31)) %]</nobr></td>
   <td><nobr>[% jetzt31 %]</nobr></td>
   <td><nobr>[% jetztgl31 %]</nobr></td>
   <td><nobr>[% jetztgk31 %]</nobr></td>
@@ -402,7 +403,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 <tr class="grey"><td class="left right" colspan="11">&nbsp;</td></tr>
 
 <tr class="white">
-  <td class="left"><nobr>Zinsertr&auml;ge</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(32)) %]</nobr></td>
   <td><nobr>[% jetzt32 %]</nobr></td>
   <td><nobr>[% jetztgl32 %]</nobr></td>
   <td><nobr>[% jetztgk32 %]</nobr></td>
@@ -416,7 +417,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Sonst. neutr. Ertr.</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(33)) %]</nobr></td>
   <td><nobr>[% jetzt33 %]</nobr></td>
   <td><nobr>[% jetztgl33 %]</nobr></td>
   <td><nobr>[% jetztgk33 %]</nobr></td>
@@ -430,7 +431,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 </tr>
 
 <tr class="white">
-  <td class="left"><nobr>Verr.kalk.Kosten</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(34)) %]</nobr></td>
   <td><nobr>[% jetzt34 %]</nobr></td>
   <td><nobr>[% jetztgl34 %]</nobr>
   <td><nobr>[% jetztgk34 %]</nobr></td>
@@ -476,7 +477,7 @@ class="right"><nobr>[% kummaufbetriebrohertrag %]</nobr>&nbsp;</td>
 <tr class="white"><td class="left right" colspan="11">&nbsp;</td></tr>
 
 <tr class="grey">
-  <td class="left"><nobr>Steuern Eink.u.Ertr.</nobr></td>
+  <td class="left"><nobr>[% HTML.escape(category_names.item(35)) %]</nobr></td>
   <td><nobr>[% jetzt35 %]</nobr></td>
   <td><nobr>[% jetztgl35 %]</nobr></td>
   <td><nobr>[% jetztgk35 %]</nobr></td>