commit d084e209b78289c547a99e8ffe045821545ae25e
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Sun Jul 28 16:41:47 2019 +0200

    Neues Design 2019 Standard-Code templates/webpages/acctranscorrections/analyze_overview.html

diff --git a/templates/webpages/acctranscorrections/analyze_overview.html b/templates/webpages/acctranscorrections/analyze_overview.html
index f503f9cf2..b5a4e4c8b 100644
--- a/templates/webpages/acctranscorrections/analyze_overview.html
+++ b/templates/webpages/acctranscorrections/analyze_overview.html
@@ -6,150 +6,149 @@
 
  <p>
   [% 'Period' | $T8 %]:
-  [%- IF transdate_from || transdate_to %]
-   [%- IF transdate_from %]
+  [% IF transdate_from || transdate_to %]
+   [% IF transdate_from %]
    [% 'from (time)' | $T8 %] [% transdate_from %]
-   [%- END %]
-   [%- IF transdate_to %]
+   [% END %]
+   [% IF transdate_to %]
    [% 'to (time)' | $T8 %] [% transdate_to %]
-   [%- END %]
-  [%- ELSE %]
+   [% END %]
+  [% ELSE %]
   [% 'all entries' | $T8 %]
-  [%- END %]
+  [% END %]
  </p>
 
- <p>
   <table width="100%">
    <tr>
-    <th class="listheading">[% 'Transaction' | $T8 %]</th>
-    <th class="listheading">[% 'Problem' | $T8 %]</th>
-    <th class="listheading">[% 'Solution' | $T8 %]</th>
+    <th>[% 'Transaction' | $T8 %]</th>
+    <th>[% 'Problem' | $T8 %]</th>
+    <th>[% 'Solution' | $T8 %]</th>
    </tr>
 
-   [%- FOREACH problem = PROBLEMS %]
+   [% FOREACH problem = PROBLEMS %]
    <tr class="listrow[% loop.count % 2 %]">
-    <td valign="top">
-     [%- IF problem.type == 'ap_ar_wrong_taxkeys' %]
-      [%- IF problem.ap_problems.size %]
+    <td>
+     [% IF problem.type == 'ap_ar_wrong_taxkeys' %]
+      [% IF problem.ap_problems.size %]
        [% 'AP Transactions' | $T8 %]
-       [%- FOREACH ap = problem.ap_problems %]
-        [%- UNLESS loop.first %], [%- END %]
+       [% FOREACH ap = problem.ap_problems %]
+        [% UNLESS loop.first %], [% END %]
         <a href="[% ap.link %]">[% HTML.escape(ap.data.reference) %]</a>
-       [%- END %]
-      [%- END %]
+       [% END %]
+      [% END %]
 
-      [%- IF problem.ar_problems.size %]
-       [%- IF problem.ap_problems.size %]; [%- END %]
+      [% IF problem.ar_problems.size %]
+       [% IF problem.ap_problems.size %]; [% END %]
        [% 'AR Transactions' | $T8 %]
-       [%- FOREACH ar = problem.ar_problems %]
-        [%- UNLESS loop.first %], [%- END %]
+       [% FOREACH ar = problem.ar_problems %]
+        [% UNLESS loop.first %], [% END %]
         <a href="[% ar.link %]">[% HTML.escape(ar.data.reference) %]</a>
-       [%- END %]
-      [%- END %]
+       [% END %]
+      [% END %]
 
 
-     [%- ELSIF problem.type == 'invoice_inventory_with_taxkeys' %]
-      [%- IF problem.ar_problems.size %]
+     [% ELSIF problem.type == 'invoice_inventory_with_taxkeys' %]
+      [% IF problem.ar_problems.size %]
        [% 'Sales invoices' | $T8 %]
-       [%- FOREACH subproblem = problem.ar_problems %]
-        [%- UNLESS loop.first %], [%- END %]
+       [% FOREACH subproblem = problem.ar_problems %]
+        [% UNLESS loop.first %], [% END %]
         <a href="[% subproblem.link %]">[% HTML.escape(subproblem.data.reference) %]</a>
-       [%- END %]
-      [%- END %]
+       [% END %]
+      [% END %]
 
-      [%- IF problem.ap_problems.size %]
-       [%- IF problem.ar_problems.size %]; [%- END %]
+      [% IF problem.ap_problems.size %]
+       [% IF problem.ar_problems.size %]; [% END %]
        [% 'Purchase invoices' | $T8 %]
-       [%- FOREACH subproblem = problem.ap_problems %]
-        [%- UNLESS loop.first %], [%- END %]
+       [% FOREACH subproblem = problem.ap_problems %]
+        [% UNLESS loop.first %], [% END %]
         <a href="[% subproblem.link %]">[% HTML.escape(subproblem.data.reference) %]</a>
-       [%- END %]
-      [%- END %]
+       [% END %]
+      [% END %]
 
-     [%- ELSIF problem.type == 'missing_taxkeys_in_invoices' %]
-      [%- IF problem.ar_problems.size %]
+     [% ELSIF problem.type == 'missing_taxkeys_in_invoices' %]
+      [% IF problem.ar_problems.size %]
        [% 'Sales invoices' | $T8 %]
-       [%- FOREACH subproblem = problem.ar_problems %]
-        [%- UNLESS loop.first %], [%- END %]
+       [% FOREACH subproblem = problem.ar_problems %]
+        [% UNLESS loop.first %], [% END %]
         <a href="[% subproblem.link %]">[% HTML.escape(subproblem.data.reference) %]</a>
-       [%- END %]
-      [%- END %]
+       [% END %]
+      [% END %]
 
-      [%- IF problem.ap_problems.size %]
-       [%- IF problem.ar_problems.size %]; [%- END %]
+      [% IF problem.ap_problems.size %]
+       [% IF problem.ar_problems.size %]; [% END %]
        [% 'Purchase invoices' | $T8 %]
-       [%- FOREACH subproblem = problem.ap_problems %]
-        [%- UNLESS loop.first %], [%- END %]
+       [% FOREACH subproblem = problem.ap_problems %]
+        [% UNLESS loop.first %], [% END %]
         <a href="[% subproblem.link %]">[% HTML.escape(subproblem.data.reference) %]</a>
-       [%- END %]
-      [%- END %]
+       [% END %]
+      [% END %]
 
-     [%- ELSE %]
+     [% ELSE %]
 
      <a href="[% problem.link %]">
-      [%- IF problem.data.module == 'ar' %]
+      [% IF problem.data.module == 'ar' %]
       [% 'AR Transaction' | $T8 %]
-      [%- ELSIF problem.data.module == 'ap' %]
+      [% ELSIF problem.data.module == 'ap' %]
       [% 'AP Transaction' | $T8 %]
-      [%- ELSE %]
+      [% ELSE %]
       [% 'General Ledger Transaction' | $T8 %]
-      [%- END %]
+      [% END %]
       [% HTML.escape(problem.data.reference) %]
      </a>
 
       <!-- ( [% problem.data.module %].id = acc_trans.trans_id = [% HTML.escape(problem.data.trans_id) %] ) -->
 
-     [%- END %]
+     [% END %]
     </td>
 
-    <td valign="top">
-     [%- IF problem.type == 'split_multiple_credit_and_debit' %]
+    <td>
+     [% IF problem.type == 'split_multiple_credit_and_debit' %]
      [% 'Transaction has been split on both the credit and the debit side' | $T8 %]
 
-     [%- ELSIF problem.type == 'wrong_taxkeys' %]
+     [% ELSIF problem.type == 'wrong_taxkeys' %]
      [% 'Wrong tax keys recorded' | $T8 %]
 
-     [%- ELSIF problem.type == 'wrong_taxes' %]
+     [% ELSIF problem.type == 'wrong_taxes' %]
      [% 'Wrong taxes recorded' | $T8 %]
 
-     [%- ELSIF problem.type == 'ap_ar_wrong_taxkeys' %]
+     [% ELSIF problem.type == 'ap_ar_wrong_taxkeys' %]
      [% 'AP transactions with sales taxkeys and/or AR transactions with input taxkeys' | $T8 %]
 
-     [%- ELSIF problem.type == 'invoice_inventory_with_taxkeys' %]
+     [% ELSIF problem.type == 'invoice_inventory_with_taxkeys' %]
      [% 'Sales and purchase invoices with inventory transactions with taxkeys' | $T8 %]
 
-     [%- ELSIF problem.type == 'missing_taxkeys_in_invoices' %]
+     [% ELSIF problem.type == 'missing_taxkeys_in_invoices' %]
      [% 'Missing taxkeys in invoices with taxes.' | $T8 %]
 
-     [%- END %]
+     [% END %]
     </td>
 
-    <td valign="top">
-     [%- IF problem.type == 'split_multiple_credit_and_debit' %]
+    <td>
+     [% IF problem.type == 'split_multiple_credit_and_debit' %]
      [% 'This transaction has to be split into several transactions manually.' | $T8 %]
 
-     [%- ELSIF (problem.type == 'wrong_taxkeys') || (problem.type == 'wrong_taxes') %]
+     [% ELSIF (problem.type == 'wrong_taxkeys') || (problem.type == 'wrong_taxes') %]
      <a href="acctranscorrections.pl?action=assistant&trans_id=[% HTML.url(problem.data.trans_id) %]&trans_module=[% HTML.url(problem.data.module) %]&trans_reference=[% HTML.url(problem.data.reference) %]&callback=[% callback %]">
       [% 'Start the correction assistant' | $T8 %]
      </a>
 
-     [%- ELSIF problem.type == 'ap_ar_wrong_taxkeys' %]
+     [% ELSIF problem.type == 'ap_ar_wrong_taxkeys' %]
      <a href="acctranscorrections.pl?action=assistant_for_ap_ar_wrong_taxkeys&callback=[% callback %]">
       [% 'Start the correction assistant' | $T8 %]
      </a>
 
-     [%- ELSIF problem.type == 'invoice_inventory_with_taxkeys' %]
+     [% ELSIF problem.type == 'invoice_inventory_with_taxkeys' %]
      <a href="acctranscorrections.pl?action=assistant_for_invoice_inventory_with_taxkeys&callback=[% callback %]">
       [% 'Start the correction assistant' | $T8 %]
      </a>
 
-     [%- END %]
+     [% END %]
     </td>
    </tr>
-   [%- END %]
+   [% END %]
 
   </table>
- </p>
+
 
  <hr>
 